#include <amxmodx>
#include <amxmisc>
#include <fakemeta>
#include <hamsandwich>

#define IsPlayer(%1) (%1>=1&&%1<=32)

///////////////////////////////////////////////////////////////////////////////////////////////////
//------------------------------------------| Immolate |-------------------------------------------
//========================================== sDs|Aragon* ==========================================
/*
Immolate - La activare dai foc unui inamic pe care pui cursorul, acesta va continua sa arda timp de 5 secunde.
#War3ft - refacut de Aragon*
*/

/////////////
// Settings |
//==========/

#define IMMOLATE_DAMAGE			50.0
#define IMMOLATE_DAMAGE_DOT		5.0

#define SOUND_IMMOLATE		"warcraft3/ImmolationDecay1.wav"
#define SOUND_IMMOLATE_BURNING	"ambience/flameburst1.wav"

////////////
// Globals |
//=========/

#define TASKID_IMMOLATE_BURNING		410

new SPR_IMMOLATE, SPR_IMMOLATE_BURNING, SPR_IMMOLATE_FIRE;
new MSGID_ScreenShake, MSGID_ScreenFade
new bool:burning[MAX_PLAYERS + 1]

public plugin_init()
{
	register_clcmd("amx_fire", "clcmd_fire")
	RegisterHamPlayer(Ham_Killed, "player_killed", 1)
	RegisterHam(Ham_Touch, "player", "player_touch")

	MSGID_ScreenShake 	= get_user_msgid("ScreenShake");
	MSGID_ScreenFade 	= get_user_msgid("ScreenFade");
}

public plugin_precache()
{
	SPR_IMMOLATE = precache_model("sprites/Furien40/fireball.spr");
	SPR_IMMOLATE_BURNING = precache_model("sprites/xfire.spr");
	SPR_IMMOLATE_FIRE = precache_model("sprites/explode1.spr");
	
	precache_sound(SOUND_IMMOLATE);
	precache_sound(SOUND_IMMOLATE_BURNING);
}

Immolate_OnDisconnect(id)
{
	remove_task(TASKID_IMMOLATE_BURNING + id);
	burning[id] = false
}
public client_disconnected(id)
{
	Immolate_OnDisconnect(id);
}

public clcmd_fire(attacker)
{
	new arg[8], victim
	read_args(arg, charsmax(arg))
	if ((victim = cmd_target(attacker, arg)))
		Immolate(victim, attacker)
}

public TASK_Immolate_Burning(parm[3]) {
	new Caster = parm[0],
	Target = parm[1],
	Counter = parm[2];

	if (!Counter)
	{
		user_kill(Target)
		burning[Target] = false
	}
	
	if (!is_user_alive(Target))
		return;
	
	new TargetOrigin[3];
	get_user_origin(Target, TargetOrigin);
			
	Create_Sprite(TargetOrigin, SPR_IMMOLATE_FIRE, 3, 200);
			
	emit_sound(Target, CHAN_STATIC, SOUND_IMMOLATE_BURNING, 0.5, ATTN_NORM, 0, PITCH_NORM);
	Create_ScreenFade(Target, 0.5, 0.5, 255, 0, 0, 80);
	Create_ScreenShake(Target, 3.0, 0.5, 2.0);
			
	if (get_user_health(Target) - IMMOLATE_DAMAGE_DOT)
		ExecuteHam(Ham_TakeDamage, Target, Caster, Caster, IMMOLATE_DAMAGE_DOT, DMG_BURN);
	else
	{
		user_kill(Target)
		burning[Target] = false
	}

	parm[2]--;
	set_task(1.0, "TASK_Immolate_Burning", TASKID_IMMOLATE_BURNING + Target, parm, 3);
}

public Immolate(victim, attacker)
{
	new Float:Origin[3], parm[3];
	pev(victim, pev_origin, Origin);
	parm[0] = attacker;
	parm[1] = victim;
	parm[2] = 3;
	burning[victim] = true

	Create_ExplosionF(Origin, SPR_IMMOLATE, 20, 24, TE_EXPLFLAG_NOSOUND | TE_EXPLFLAG_NODLIGHTS | TE_EXPLFLAG_NOPARTICLES);
	Create_ExplosionF(Origin, SPR_IMMOLATE_BURNING, 30, 24, TE_EXPLFLAG_NOSOUND | TE_EXPLFLAG_NODLIGHTS | TE_EXPLFLAG_NOPARTICLES);
	
	emit_sound(attacker, CHAN_STATIC, SOUND_IMMOLATE, 0.5, ATTN_NORM, 0, PITCH_NORM);
	Create_ScreenFade(victim, 0.75, 0.75, 255, 0, 0, 100);
	Create_ScreenShake(victim, 3.0, 0.75, 2.0);
	
	if (get_user_health(victim) - IMMOLATE_DAMAGE >= 1)
		ExecuteHam(Ham_TakeDamage, victim, attacker, attacker, IMMOLATE_DAMAGE, DMG_BURN);
	else
	{
		user_kill(victim)
		burning[victim] = false
	}
	
	set_task(1.0, "TASK_Immolate_Burning", TASKID_IMMOLATE_BURNING + victim, parm, 3);
}

public player_killed(victim)
	Immolate_OnDisconnect(victim);

public player_touch(id, partner)
{
	if (IsPlayer(id) && IsPlayer(partner))
	{
		if (is_user_alive(id) && is_user_alive(partner))
		{
			if (burning[id] && !burning[partner])
				Immolate(partner, id)
		}
	}
}

stock Create_ExplosionF(Float:Origin[3], Sprite, Scale, FrameRate, Flags) {
	engfunc(EngFunc_MessageBegin, MSG_PAS, SVC_TEMPENTITY, Origin);
	write_byte(TE_EXPLOSION);
	engfunc(EngFunc_WriteCoord, Origin[0]);	// Pos	- X	- Position of the explosion effect
	engfunc(EngFunc_WriteCoord, Origin[1]);	// Pos	- Y	- Position of the explosion effect
	engfunc(EngFunc_WriteCoord, Origin[2]);	// Pos	- Z	- Position of the explosion effect
	write_short(Sprite);	// Sprite		- path	- The additive Sprite to use in the explosion
	write_byte(Scale);		// Scale		- 0-255	- The Scale of the Sprite in the explosion, in 0.1s
	write_byte(FrameRate);	// FrameRate	- 0-255	- The frame rate to show the Sprite at, in 0.1s (10 = 1 fps)
	write_byte(Flags);		// Flags		- 0-15	- Sets flags for the explosion, you may also add these together:
	message_end();
	/*
	Flags:
	0: Default Half-Life explosion
	1: Sprite will be drawn opaque
	2: Do not render the dynamic lights
	4: Do not play the explosion sound
	8: Do not draw the particles
	*/
}

stock Create_ScreenFade(id, Float:Duration, Float:HoldTime, Red, Green, Blue, Alpha) {
	new iDuration = clamp(floatround(Duration * (1 << 12)), 0, 0xFFFF),
	iHoldTime = clamp(floatround(HoldTime * (1 << 12)), 0, 0xFFFF);
	
	message_begin(id ? MSG_ONE : MSG_ALL, MSGID_ScreenFade, _, id);
	write_short(iDuration);
	write_short(iHoldTime);
	write_short(0x0000);
	write_byte(Red);
	write_byte(Green);
	write_byte(Blue);
	write_byte(Alpha);
	message_end();
}

stock Create_ScreenShake(id, Float:Amount, Float:Duration, Float:Frequency) {
	new iAmount = clamp(floatround(Amount * (1 << 12)), 0, 0xFFFF),
	iDuration = clamp(floatround(Duration * (1 << 12)), 0, 0xFFFF),
	iFrequency = clamp(floatround(Frequency * (1 << 12)), 0, 0xFFFF);
	
	message_begin(id ? MSG_ONE : MSG_ALL, MSGID_ScreenShake, _, id);
	write_short(iAmount);
	write_short(iDuration);
	write_short(iFrequency);
	message_end();
}

stock Create_Sprite(Origin[3], Sprite, Scale, Brightness) {
	message_begin(MSG_PAS, SVC_TEMPENTITY, Origin);
	write_byte(TE_SPRITE);
	write_coord(Origin[0]);	// Pos			- X		- Position of the Sprite effect
	write_coord(Origin[1]);	// Pos			- Y		- Position of the Sprite effect
	write_coord(Origin[2]);	// Pos			- Z		- Position of the Sprite effect
	write_short(Sprite);	// Sprite		- path	- The Sprite to use
	write_byte(Scale);		// Scale		- 0-255	- The Scale of the Sprite, in 0.1s
	write_byte(Brightness);	// Brightness	- 0-255	- The Brightness of the Sprite
	message_end();
}

///////////////////////////////////////////////////////////////////////////////////////////////////
//------------------------------------------| Immolate |-------------------------------------------
//========================================== sDs|Aragon* ==========================================